// 删除单向链表中一个节点。
// 要点：
//     从表头开始顺序查找链表中节点值为给定值的第一个节点并删除之。
//     函数返回删除后的表头指针。
// 关键字:单向链表 删除 幽灵变量
#include <stddef.h>
#include <stdlib.h>

#define N 100
typedef struct node{
    struct node *next;
    int data;
}Node;
//@ shape next: list;  //声明结构体自引用next域构成单向链表

//@ logic Node* oldhead;
//@ ghost int oldj;
/////////////////////////////////////delete函数的验证///////////////////////////////////////
// 函数协议：
//     前条件：head指向长为m的单向链表
//     后条件：head指向一个单向链表，1）长度为m-1，即存在一个节点，其data域值等于data；或2）长度为m，
//            即不存在一个节点，其data域值等于data；3）头结点（head）被删除的情况。同时还具有链表中
//            在被删除的节点之前没有其它data域值等于data的节点。
//            
/*@ 
  requires 
      oldhead == head && \list(head) && \length(head, next) == m && m >= 0 && m <= N;
  assigns head,oldj;          
  ensures 
      (\list(oldhead) && m <= N && \length(oldhead, next) == m && m >= 0 && \result == oldhead         
       || 
       \list(oldhead) && m <= N && \length(oldhead, next) == m-1 && m-1 >= 0 && \result == oldhead
       ||
       \dangling(oldhead) && m >= 1 && m <= N && \list(\result) && \length(\result, next) == m-1
      )
      && (\forall int i:[0..oldj-2].\result->(next:i)->data != data) && 0 <= oldj <= m
      ;
*/
Node* delete(Node* head, const int data, const int m) {
    Node *ptr;
    Node *ptr1;
    int j;

    j = 1;
    //@ ghost oldj = 0;
    if(head != NULL){
        ptr1 = head;
        ptr = head->next;
        if(ptr1->data == data){
            if(ptr == NULL){ 
                free(head);
                return NULL;
            }
            else {
                ptr1 = NULL;
                free(head);
                return ptr;
            }
        } 
        /*@ loop invariant
              //循环不变式描述链表，从左到右依次描述每个节点
              oldhead == head && \list_seg(head, ptr1) && ptr1 == head->(next:j-1) 
              //描述以head指向节点到ptr1指向节点构成单向链表表段，且长度为j
              && ptr == ptr1->next 
              && (\forall int i:[0..j-1].head->(next:i)->data != data)
              && \list(ptr) && \length(ptr, next) == m - j 
              //描述以ptr指向节点为头节点的长度为 m - j 的单向链表
              && m >= 1 && 1 <= j <= m && m <= N 
            ||
              oldhead == head && \list_seg(head, ptr1) && ptr1 == head->(next:j-1) 
              && \list(ptr1) && \length(ptr1, next) == 1
              && (\forall int i:[0..j-1].head->(next:i)->data != data)
              && ptr == \null && m >= 1 && j == m && m <= N
              ;
        */
        while((ptr != NULL) && (ptr->data < data)){
            ptr1 = ptr;
            ptr = ptr->next;
            j = j + 1;
        }
        //@ ghost oldj = j;
        if((ptr != NULL) && (ptr->data == data)){
            ptr1->next = ptr->next; 
            free(ptr);
            return head;
        }        
    }
    return head;
}